/*
 * Copyright (c) 2008-2010 Nokia Corporation and/or its subsidiary(-ies). All rights reserved.
 *    
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *    
 *  * Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *  * Neither the name of Nokia Corporation nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *    
 *    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 *    AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 *    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 *    DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 *    FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 *    DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 *    SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 *    CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 *    OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 *    OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *    
 *    Description:  
 */

#ifndef CALENDARAPIEXAMPLEENTRYITEMLIST_H
#define CALENDARAPIEXAMPLEENTRYITEMLIST_H

// INCLUDE FILES
#include <aknsettingitemlist.h>
#include "calendarapiexample.hrh"

// FORWARD DECLARATIONS
class CCalHelperEntry;
class CAknView;

// CLASS DECLARATION

class CCalendarAPIexampleEntryItemList : public CAknSettingItemList
    {
public: // New functions

   /*!
    * SetData()
    *
    * Sets values to itemlist from given entry.
    */
    void SetData(const CCalHelperEntry& aData);
        
   /*!
    * SaveL()
    *
    * Sets values from itemlist to given entry.
    * Returns true if user input is valid, otherwise false is returned.
    */
    TBool SaveL();

    /*!
     * Gets the values set.
     *
     *
     */
    void GetValues(TDes& aName, TTime& aDate,
                   TBool& aAlarm, TTime& aAlarmTime,
                            TInt& aSync);
    
    void SetValues(         const TDesC& aName,
                            const TDateTime& aDate,
                            const TBool& aAlarm,
                            const TDateTime& aAlarmTime,
                            const TInt& aSync);                            
   /*!
    * From CCoeControl,SizeChanged
    */

private: // Functions from base classes

   /*!
    * From CAknSettingItemList,CreateSettingItemL
    */
    CAknSettingItem* CreateSettingItemL( TInt aIdentifier );

    
private: // Data members

    TBuf<KMaxNameLength> iName;
    TTime iDate;
    TBool iAlarm;
    TTime iAlarmDate;
    TTime iAlarmTime;
    TInt iSync;

    };

#endif
